using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using System.Text;

namespace InsideAspNetP2
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page, IPostBackDataHandler
	{

		#region Page Controls
		protected System.Web.UI.HtmlControls.HtmlForm Form1;

		protected System.Web.UI.WebControls.Panel Panel1;
		protected System.Web.UI.WebControls.TextBox TextBox1;
		protected System.Web.UI.WebControls.Button Button1;
		protected System.Web.UI.WebControls.LinkButton LinkButton1;
		protected System.Web.UI.WebControls.ImageButton ImageButton1;
		protected System.Web.UI.WebControls.DropDownList DropDownList1;
		protected System.Web.UI.WebControls.ListBox ListBox1;
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Web.UI.WebControls.CheckBox CheckBox1;
		protected System.Web.UI.WebControls.CheckBoxList CheckBoxList1;
		protected System.Web.UI.WebControls.RadioButtonList RadioButtonList1;
		protected System.Web.UI.WebControls.Image Image1;
		protected System.Web.UI.WebControls.Panel Panel2;
		protected System.Web.UI.WebControls.AdRotator AdRotator1;
		protected System.Web.UI.WebControls.Panel PanelSummary;
		protected System.Web.UI.WebControls.Calendar Calendar1;
		#endregion

		#region Helper Functions
		private string getTreeSize(Control CurrentControl)
		{
			int i=0;

			foreach (Control c in CurrentControl.Controls)
			{
				i++;
				if (c.HasControls()) i+= int.Parse(getTreeSize(c));
			}

			return i.ToString();
		}

		private void hideControlsWhenTracing()
		{
			if (this.Trace.IsEnabled)
			{
				hideControlTree(this);	
			}
		}

		private void hideControlTree(Control CurrentControl)
		{
			foreach (Control c in CurrentControl.Controls)
			{
				if (
						!(
							(c is System.Web.UI.HtmlControls.HtmlForm) ||
							(c is System.Web.UI.HtmlControls.HtmlInputButton)
						) 
					)
					c.Visible=false;

				if (c.HasControls()) hideControlTree(c);
			}
		}

		private void DumpControlTree(Control CurrentControl, int Level, ref StringBuilder sb)
		{
			string indentChars = string.Empty;

			for (int i=1; i<Level; i++)
				indentChars += "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";

			foreach (Control c in CurrentControl.Controls)
			{
				sb.Append(indentChars + "<b>" + c.UniqueID +  "</b> (" + c.GetType().ToString() + ")<br>");
				if (c.HasControls()) DumpControlTree(c, ++Level, ref sb);
			}

			//sb.Append("<hr>");
		}
		#endregion

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Unload += new System.EventHandler(this.Page_Unload);
			this.Load += new System.EventHandler(this.Page_Load);
			this.Init += new System.EventHandler(this.Page_Init);
			this.PreRender += new System.EventHandler(this.Page_PreRender);

		}
		#endregion

		#region Page Events
		private void Page_Init(object sender, System.EventArgs e)
		{
			Trace.Warn("Page_Init, control count is " + getTreeSize(this));
		}

		protected override void LoadViewState(object savedState)
		{
			Trace.Warn("LoadViewState, control count is " + getTreeSize(this));

			
			
			base.LoadViewState(savedState);
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			Trace.Warn("Page_Load, control count is " + getTreeSize(this));

			StringBuilder sb = new StringBuilder();

			//build the control tree into this string builder
			DumpControlTree(this,0,ref sb);

			//Now Add a control with the control tree
			PanelSummary.Controls.Add(new LiteralControl(sb.ToString()));

			hideControlsWhenTracing();	
			//this.Controls.AddAt(this.Controls.Count,new LiteralControl("<br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br>"));
			//PanelSummary.Visible=false;

			//Add a Standard HTML Button to Force a Re-GET of this Page
			string sHtml = @"<!-- Std HtmlButton (not Run on Server), use JavaScript to re-GET this Page -->";
			sHtml += "<input type=button onclick=\"location.href='ControlTree.aspx'\" value=\"Re-GET Page\">";

			this.FindControl("Form1").Controls.Add(new LiteralControl(sHtml));
		}

		#region Implementation of IPostBackDataHandler
		public void RaisePostDataChangedEvent()
		{
			Trace.Warn("RaisePostDataChangedEvent()");
		}

		public bool LoadPostData(string postDataKey, System.Collections.Specialized.NameValueCollection postCollection)
		{
			return true;
		}
		#endregion

		private void Page_PreRender(object sender, System.EventArgs e)
		{
			Trace.Warn("PreRender, control count is " + getTreeSize(this));
		}

		protected override object SaveViewState()
		{
			Trace.Warn("SaveViewState, control count is " + getTreeSize(this));

			object o = base.SaveViewState();

			//Add a lot of Fake View State (Notice how trace doesn't see this)
			//object[] oAll = new object[] {new int[10000],o};
			//return oAll;

			return o;
		}

		private void Page_Render(object sender, System.EventArgs e)
		{
			Trace.Warn("Page_Render, control count is " + getTreeSize(this));
		}

		protected override void Render(HtmlTextWriter output)
		{
			Trace.Warn("Render, control count is " + getTreeSize(this));
			base.Render(output);
		}

		public override void Dispose()
		{
			//Tracing seems to be gone here, so we'll try something else:
			System.Diagnostics.Debug.WriteLine("Dispose, control count is " + getTreeSize(this));
			base.Dispose();
		}

		private void Page_Unload(object sender, System.EventArgs e)
		{
			//Tracing seems to be gone here, so we'll try something else:
			System.Diagnostics.Debug.WriteLine("Page_Unload, control count is " + getTreeSize(this));
		}
		#endregion //Page Events
	}
}
